#!/usr/bin/env python

from pyparsing import *

class Grammar:
    def __setattr__(self, name, value):
        self.__dict__[name] = Group(value).setResultsName(name)

g = Grammar()

g.non_literal = OneOrMore(CharsNotIn("'"))
g.value = ZeroOrMore(Or([Literal("''"), CharsNotIn("'")]))
g.literal = Literal("'") + g.value + Literal("'")
g.query = ZeroOrMore(Or([g.non_literal, g.literal]))
g.query.leaveWhitespace()

def parseString(s):
    return g.query.parseString(s)

# vim: tabstop=4 expandtab shiftwidth=4
